﻿<!--
//
// (c) CANON INC. 2005
//
var xmldoc = new ActiveXObject("Microsoft.XMLDOM");
xmldoc.async = false;
xmldoc.validateOnParse = true;
var structure = new Array("chapter","section","clause","subclause","smallclause");
function search(val){
    var str = trim(val);
    if(str=='') return;
    var stime = new Date().getTime();
    var statusstr = "Searching. ";
    status=statusstr;
    var resultCount = 0;
    var result = "";
    var structureCd2 = new Array();
    var ctype = 0;
    
    xmldoc.load("../../searchindex.xml");
    if(xmldoc.selectSingleNode("index_info")==null) {
        return;
    }
    
    var infoNode = xmldoc.selectSingleNode("index_info");
    var leafNodes = infoNode.childNodes;
   
   for(var iLeafNode=0;iLeafNode<leafNodes.length;iLeafNode++){
   	   
        if(iLeafNode%10==0){
            status=statusstr + Math.round(iLeafNode/leafNodes.length*100) + "%";
        }
	    var flg = false;
		var alltext = "";
		var leafNode;
		leafNode= infoNode.childNodes.item(iLeafNode);
		
    	alltext = leafNode.selectSingleNode("alltext").text;
    	alltext = alltext.toUpperCase();
        alltext = replace2byte(alltext);
        str = str.replace(/\s+|　+/g," ");
        str = str.toUpperCase();
        str = replace2byte(str);
        var strs = str.split(" ");
        for(var i = 0; i < strs.length; i++){
            if(alltext.indexOf(strs[i]) > -1){
                flg = true;
            }else{
                flg = false;
                break;
            }
        }
        if(flg){
            var title = leafNode.selectSingleNode("title").text;
            if(title==''){
                title = "&nbsp;";
            }else{
                title = escapeHtml(title);
            }
            
            var structureNodeList = leafNode.getElementsByTagName("structure");
            var structureNm = new Array();
            var structureCd = new Array();
            for(var i = 0; i < structure.length; i++){
            	structureNm[i] = getNameFromPageInfo(leafNode,structure[i]);
                structureCd[i] = getCodeFromPageInfo(leafNode,structure[i]);
            	
                //structureNm[i] = "<li><span class='navi'>"+structureNodeList.item(i).selectSingleNode("name").text;
                //structureCd[i] = structureNodeList.item(i).selectSingleNode("code").text;
            }
            	
            for(var i = 0; i < structure.length; i++){
                if(structureCd[i] != structureCd2[i]){
                    for(var j = 0; j < ctype - i ; j++){
                        result += "</ul>";
                    }
                    result += structureNm[i]+"&nbsp;</span></li><ul>";
                    ctype = i + 1;
                    for(var j = i + 1 ; j < structure.length; j++){
                        if(structureCd[j]!=""){
                            result += "<li>"+structureNm[j]+"</li><ul>";
                            ctype = j + 1;
                        }
                    }
                    break;
                }
            }
            leafId = leafNode.attributes.item(0).text;
            result += "<li class='leaf'><a href='../../leaves/"+leafId+"/top.html' target='contentsframe'><span class='link'>" 
                + title + "</span></a></li>";
            resultCount++;
            for(var i = 0; i < structure.length; i++){
                structureCd2[i] = structureCd[i];
            }		
        }
    }
    window.parent.searchbody.document.getElementById("searchresultbody").innerHTML = "<ul>" + result + "</ul>";
    var etime = new Date().getTime();
    status="Done.  " + ( etime - stime )/1000 + "sec.  " + resultCount +"Hits." ;
    return resultCount;
}
function getNameFromPageInfo(leafNode,val) {
    var tempNode = leafNode.selectSingleNode(val);
    var ret = "";
    if(tempNode!=null && tempNode.selectSingleNode("name")!=null){
        ret = "<span class='navi'>"+ escapeHtml(tempNode.selectSingleNode("name").text) +"&nbsp;</span>";
    }
    return ret;
}
function getCodeFromPageInfo(pageInfo,val) {
    var tempNode = pageInfo.selectSingleNode(val);
    var ret = "";
    if(tempNode!=null && tempNode.selectSingleNode("code")!=null){
        ret = tempNode.selectSingleNode("code").text;
    }
    return ret;
}
function getAttribute(searchNode,parentNode,attributeName){
    var ret = "";
    var objCol = searchNode.getElementsByTagName(parentNode);
    for (var i=0; i< objCol.length; i++) {
        var att = objCol(i).getAttributeNode(attributeName);
        if(att != null) {
            ret += att.nodeValue;
        }
    }
    return ret;
}
function getText(searchNode,parentNode,childNode){
    var ret = "";
    var tempNode = searchNode.selectSingleNode(parentNode);
    if(tempNode!=null && tempNode.selectSingleNode(childNode)!=null){
        ret = tempNode.selectSingleNode(childNode).text;
    }
    return ret;
}
function trim(targetString){
    return targetString.replace(/^(\s*)(\S(.*\S)?)?(\s*)$/, "$2");
}
function replace2byte(str){
    if(contains2byte(str)){
        for(var i = 0; i < num2.length; i++){
            str = str.replace(regs[i],num1[i]);
        }
    }
    return str;
}
function contains2byte(str){
    return str.match(/[０-９]|[Ａ-Ｚ]|！|”|＃|＄|％|＆|’|（|）|＝|｜|‘|＋|＊|＜|＞|？|＿|＾|￥|＠|；|：|、|。|・/);
}
function escapeHtml(str){
    return str.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
}
var num2 = new Array("１","２","３","４","５","６","７","８","９","０","Ａ","Ｂ","Ｃ","Ｄ","Ｅ","Ｆ","Ｇ","Ｈ","Ｉ","Ｊ","Ｋ","Ｌ","Ｍ","Ｎ","Ｏ","Ｐ","Ｑ","Ｒ","Ｓ","Ｔ","Ｕ","Ｖ","Ｗ","Ｘ","Ｙ","Ｚ"
    ,"！","”","＃","＄","％","＆","’","（","）","＝","｜","‘","＋","＊","＜","＞","？","＿","＾","￥","＠","；","：","、","。","・");
var num1 = new Array("1","2","3","4","5","6","7","8","9","0","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"
    ,"!","\"","#","$","%","&","'","(",")","=","|","`","+","*","<",">","?","_","^","\\","@",";",":",",",".","･");
var regs = new Array();
for(var i = 0; i < num2.length; i++){
    regs[i] = new RegExp(num2[i], "g");
}
//-->